﻿using System;
using System.Diagnostics;


namespace SpaceInvaders
{
    public class RightBumper : Bumpers
    {
        //-------------------------------------------------------------------
        //  CONSTRUCTION
        //-------------------------------------------------------------------

        public RightBumper(GameObject.ObjectName objName, Sprite.SpriteName spriteName, float x, float y, float width, float height)
            : base(objName, spriteName, x, y, Bumpers.BumperType.RightBumper)
        {
            this.x = x;
            this.y = y;

            this.pColObj.pCollisionRect.Set(x, y, width, height);
            this.SetCollisionColor(0.0f, 1.0f, 0.0f);
        }


        //-------------------------------------------------------------------
        //  PUBLIC METHODS
        //-------------------------------------------------------------------

        public override void Update()
        {
            base.Update();
        }


        //-------------------------------------------------------------------
        //  ACCEPT METHODS
        //-------------------------------------------------------------------

        public override void Accept(Visitor other)
        {
            other.Visit(this);
        }

        public override void Visit(ShipRoot ship)
        {
            CollisionPair pPair = CollisionPairMan.GetActivePair();
            Debug.Assert(pPair != null);

            pPair.SetCollision(ship, this);
            pPair.NotifyListeners();
        }


    } //end class

} //end namespace
